import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import React from "react";
import { Box } from "@chakra-ui/layout";
import { Flex, useOutsideClick } from "@chakra-ui/react";
import { useDragLayer, useDrop } from "react-dnd";
import { css } from "@emotion/react";
const acceptMap = {
    layout: ["container"],
    container: ["element", "layout", "container"],
    element: [],
};
const EditModeWrapper = ({ children, isActive, onClick, onBlur, instance, display }) => {
    const [{ canDrop, isOver }, drop] = useDrop(() => ({
        accept: acceptMap[instance.kind] || "element",
        drop: (_item, monitor) => {
            const didDrop = monitor.didDrop();
            if (didDrop) {
                return;
            }
            return { instance };
        },
        collect: (monitor) => ({
            isOver: monitor.isOver({ shallow: true }),
            canDrop: monitor.canDrop(),
        }),
    }));
    const isDragActive = canDrop && isOver;
    const { isDragging } = useDragLayer((monitor) => ({
        isDragging: monitor.isDragging(),
    }));
    const ref = React.useRef();
    useOutsideClick({
        ref: ref,
        handler: onBlur,
    });
    const wrapperStyle = ["container", "layout"].includes(instance.kind)
        ? {
            p: "1",
            bg: isDragActive ? "blue.100" : "blackAlpha.50",
            border: "1px dashed #fff",
            css: css `
          &:after {
            content: "${instance.componentID}";
            position: absolute;
            top: -5px;
            left: 6px;
            font-size: 9px;
            background: #fff;
            padding: 0 2px;
            border-radius: 3px;
            line-height: 10px;
            z-index: 1;
          }
        `,
        }
        : {
            flex: display === "block" ? 1 : undefined,
        };
    return (_jsxs(Flex, Object.assign({ ref: drop, position: "relative" }, wrapperStyle, { w: !instance.properties.width
            ? "full"
            : instance.properties.width.value === "fill"
                ? "full"
                : undefined, flex: !instance.properties.width
            ? "1"
            : instance.properties.width.value === "fill"
                ? "1"
                : instance.properties.width.value === "hug"
                    ? "0"
                    : `0 0 ${instance.properties.widthSize}px`, maxH: !instance.properties.height
            ? undefined
            : instance.properties.height.value === "fixed"
                ? `${Number(instance.properties.heightSize) + 10}px`
                : undefined, alignSelf: !instance.properties.height
            ? "stretch"
            : instance.properties.height.value === "fill"
                ? "stretch"
                : "auto" }, { children: [_jsx(Box, { ref: ref, position: "absolute", top: "0", bottom: "0", left: "0", right: "0", rounded: "sm", border: isActive ? "1px solid" : undefined, borderColor: "blue.300", pointerEvents: isDragging ? "none" : undefined, zIndex: 1, cursor: "pointer", transition: "all 50ms ease-out", _hover: {
                    bg: "blue.100",
                    opacity: 0.2,
                }, onClick: onClick }), children] })));
};
export default EditModeWrapper;
//# sourceMappingURL=EditModeWrapper.js.map